@using Microsoft.Extensions.Localization
@using Microsoft.EntityFrameworkCore
@inherits LayoutComponentBase
@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IDialogService _dialogService
@inject IJSRuntime _jsRuntime
@inject IStringLocalizer<MainLayout> _localizer
@inject NavigationManager _navigationManager
@inject UserManager<User> _userManager

@inject ISnackbar _snackbar

<MudLayout>
    @* Application bar swipe area *@
    <MudSwipeArea OnSwipe="@OnSwipe">
        @* Application bar *@
        <MudAppBar Class="appbar-blurred" Elevation="0">
            <MudIconButton Icon="@Icons.Material.Filled.Menu" Color="Color.Inherit" Edge="Edge.Start" OnClick="@(_ => DrawerToggle())"/>
            <MudText Typo="Typo.h5" Class="ml-3 d-md-none" Style="font-weight: bold;">Overtest</MudText>
            <MudSpacer/>
            <MudMenu Icon="@Icons.Material.Filled.MoreVert" Color="Color.Inherit" Direction="Direction.Bottom" OffsetY="false" AnchorOrigin="@Origin.BottomRight" TransformOrigin="Origin.TopRight">
                <MudMenuItem Icon="@Icons.Filled.AccountCircle" OnClick="@(() => _navigationManager.NavigateTo("/users/profile/"))">@_localizer["Мій профіль"]</MudMenuItem>
                <MudMenuItem Icon="@Icons.Filled.Settings" OnClick="@(() => _navigationManager.NavigateTo("/users/profile/edit/"))">@_localizer["Налаштування"]</MudMenuItem>
                <MudDivider/>
                <MudMenuItem Icon="@Icons.Filled.Link" OnClick="@(async () => await OpenLinkAsync("https://overtest.sirkadirov.com/"))">@_localizer["Офіційний сайт Overtest"]</MudMenuItem>
                <MudMenuItem Icon="@Icons.Filled.Link" OnClick="@(async () => await OpenLinkAsync("https://docs.overtest.sirkadirov.com/"))">@_localizer["Настанови з використання"]</MudMenuItem>
                <MudDivider/>
                <MudMenuItem Icon="@Icons.Filled.Logout" OnClick="@(async () => await ConfirmLogoutAsync())">@_localizer["Вийти з системи"]</MudMenuItem>
            </MudMenu>
        </MudAppBar>
        @* /Application bar *@
    </MudSwipeArea>
    @* /Application bar swipe area *@
    
    @* Main application drawer *@
    <MudDrawer @bind-Open="_drawerOpen" ClipMode="DrawerClipMode.Never" Elevation="1">
        @* Main navigation menu *@
        <MudNavMenu Class="py-2">
            @* Drawer header *@
            <div>
                <MudText Typo="Typo.h5" Class="px-4" Style="font-weight: bold;">Overtest</MudText>
                <MudText Typo="Typo.body2" Class="px-4 mud-text-secondary">@_localizer["Електронний освітній ресурс для викладання курсів і проведення змагань з програмування."]</MudText>
                <MudDivider Class="my-2"/>
            </div>
            @* /Drawer header *@
            
            <MudNavLink Icon="@Icons.Filled.Home" OnClick="@(() => _navigationManager.NavigateTo("/"))">@_localizer["Головна сторінка"]</MudNavLink>
            
            @* Users section *@
            <MudNavGroup Icon="@Icons.Filled.GroupWork" Title="@_localizer["Користувачі"]" Expanded="true">
                <MudNavLink Href="/users/rating/">@_localizer["Глобальний рейтинг"]</MudNavLink>
                <MudNavLink OnClick="ShowComingSoonMessage">@_localizer["Групи користувачів"]</MudNavLink>
            </MudNavGroup>
            @* /Users section *@
            
            @* Tasks archive section *@
            <MudNavGroup Icon="@Icons.Filled.Wysiwyg" Title="@_localizer["Завдання"]" Expanded="true">
                <MudNavLink Href="/tasks/archive/">@_localizer["Архів завдань"]</MudNavLink>
                <MudNavLink Href="/tasks/deferred/">@_localizer["Відкладені завдання"]</MudNavLink>
                <MudNavLink Href="/tasks/attempts/">@_localizer["Мої спроби"]</MudNavLink>
            </MudNavGroup>
            @* /Tasks archive section *@
            
            @* Curator section *@
            @if (_currentUserType is UserType.Curator or UserType.SuperUser)
            {
                <MudNavGroup Icon="@Icons.Filled.VerifiedUser" Title="@_localizer["Панель куратора"]" Expanded="false">
                    <MudNavLink OnClick="@(() => _navigationManager.NavigateTo("/curator/invites/"))">@_localizer["Запрошувальні посилання"]</MudNavLink>
                    <MudNavLink OnClick="ShowComingSoonMessage">@_localizer["Управління користувачами"]</MudNavLink>
                    <MudNavLink OnClick="ShowComingSoonMessage">@_localizer["Управління групами"]</MudNavLink>
                </MudNavGroup>
            }
            @* /Curator section *@
            
            @* Administrative section *@
            @if (_currentUserType == UserType.SuperUser)
            {
                <MudNavGroup Icon="@Icons.Filled.Settings" Title="@_localizer["Адміністрування"]" Expanded="false">
                    <MudNavLink OnClick="ShowComingSoonMessage">@_localizer["Панель адміністратора"]</MudNavLink>
                    <MudNavLink OnClick="ShowComingSoonMessage">@_localizer["Управління користувачами"]</MudNavLink>
                    
                    <MudNavGroup Title="@_localizer["Управління завданнями"]" Expanded="true">
                        <MudNavLink OnClick="ShowComingSoonMessage">@_localizer["Панель управління"]</MudNavLink>
                        <MudNavLink Href="admin/tasks/import">@_localizer["Імпорт завдань у систему"]</MudNavLink>
                        <MudNavLink Href="admin/compilers">@_localizer["Підтримка компіляторів"]</MudNavLink>
                    </MudNavGroup>
                </MudNavGroup>
            }
            @* /Administrative section *@
        </MudNavMenu>
        @* /Main navigation menu *@
    </MudDrawer>
    @* /Main application drawer *@
    
    @* Main content container *@
    <MudMainContent>
        @Body
    </MudMainContent>
    @* /Main content container *@
</MudLayout>

<style>
    .appbar-blurred {
        background: rgba(255, 255, 255, 0.3) !important;
        backdrop-filter: blur(10px);
    }
</style>

@code {
    private bool _drawerOpen;
    private UserType? _currentUserType;

    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        
        _drawerOpen = true;
        
        await using var databaseContext = _dbContextFactory.CreateDbContext();

        var authenticationState = await _authenticationStateProvider.GetAuthenticationStateAsync();
        var currentUserId = new Guid(_userManager.GetUserId(authenticationState.User));

        _currentUserType = await databaseContext.Users.AsNoTracking()
            .Where(u => u.Id == currentUserId)
            .Select(s => s.Type).FirstAsync();
    }

    private void DrawerToggle() => _drawerOpen = !_drawerOpen;

    private void OnSwipe(SwipeDirection direction)
    {
        // ReSharper disable once SwitchStatementMissingSomeEnumCasesNoDefault
        switch (direction)
        {
            case SwipeDirection.LeftToRight when !_drawerOpen:
                _drawerOpen = true;
                StateHasChanged();
                break;
            case SwipeDirection.RightToLeft when _drawerOpen:
                _drawerOpen = false;
                StateHasChanged();
                break;
        }
    }

    private async Task OpenLinkAsync(string url, bool inNewTab = true)
    {
        await _jsRuntime.InvokeAsync<object>("open", url, inNewTab ? "_blank" : string.Empty);
    }

    private void ShowComingSoonMessage()
    {
        _snackbar.Add(_localizer["Запитуваний вами функціонал буде додано у наступних версіях системи. Стежте за оновленнями!"]);
    }
    
    private async Task ConfirmLogoutAsync()
    {
        var dialogResult = await _dialogService.ShowMessageBox(new MessageBoxOptions
        {
            Title = _localizer["Вихід з облікового запису"],
            Message = _localizer["Чи впевнені ви у тому, що хочете завершити роботу зі системою? Усю не збережену вами інформацію буде втрачено!"],
            YesText = _localizer["Вийти"],
            NoText = _localizer["Відмінити"]
        }, new DialogOptions
        {
            Position = DialogPosition.Center,
            CloseButton = true,
            DisableBackdropClick = true,
            MaxWidth = MaxWidth.Small
        });

        if (!dialogResult.HasValue || !dialogResult.Value)
            return;

        _navigationManager.NavigateTo("/Auth/LogOut", true);
    }
}